diff --git a/iccom_driver.c b/iccom_driver.c
index f2219aa..a9552f1 100644
--- a/iccom_driver.c
+++ b/iccom_driver.c
@@ -665,7 +503,6 @@ const struct iccom_ops iccom_drv_fops = {
 	.open		= &iccom_drv_open,
 	.read		= &iccom_drv_read,
 	.write		= &iccom_drv_write,
-	.ioctl		= &iccom_drv_ioctl,
 	.close		= &iccom_drv_close,
 };
 
@@ -673,262 +510,212 @@ static const struct of_device_id iccom_drv_match[] = {
 	{ .compatible = "renesas,iccom-rcar", },
 	{ }
 };
+
 MODULE_DEVICE_TABLE(of, iccom_drv_match);
 
 static int32_t iccom_drv_probe(struct platform_device *pdev)
 {
-	struct iccom *l_iccom = NULL;
+	struct iccom *iccom = NULL;
 	struct iccom_hardware_info *iccom_hw = NULL;
 	struct resource mfis_base;
-	struct resource *req_iicr;
-	struct resource *req_eicr;
-	struct resource *req_imbr;
-	struct resource *req_embr;
-	struct resource *req_cta;
-	int32_t ret = ICCOM_OK;
-	int32_t ret_irq;
-	int32_t ret_get_irq;
-	const void *reg_offset_ptr;
-	const void *cta_addr_ptr;
-	const void *ack_timer_ptr;
-	const void *trg_timer_ptr;
+	struct resource *req_res;
+	int32_t ret = 0;
+	const void *dts_val_ptr;
 	struct device_node *dev_node;
-	int8_t channel_name[ICCOM_CANNEL_NO_LEN];
+	int8_t channel_name[ICCOM_MAX_NAME_LENGTH];
 	int32_t len;
-	enum Iccom_channel_number i;
-	enum Iccom_channel_number l_channel_no = ICCOM_CHANNEL_MAX;
-	size_t fixed_len;
+	enum iccom_channel_number i;
+	enum iccom_channel_number l_channel_no = ICCOM_CHANNEL_MAX;
+	size_t dts_name_len;
 	uint8_t request_flg = 0U;
 	int32_t ret_cmp;
 
-	pr_debug("%s: Start\n", __func__);
-
 	dev_node = dev_of_node(&pdev->dev);
-	if (dev_node != NULL) {
-		fixed_len = strlen(dev_node->name);
-		for (i = ICCOM_CHANNEL_0; i < ICCOM_CHANNEL_MAX; i++) {
-			(void)snprintf(channel_name, ICCOM_CANNEL_NO_LEN,
-					"%d", i);
-			ret_cmp = strncmp(&dev_node->name[fixed_len - 1U],
-				channel_name, strlen(channel_name));
-			if (ret_cmp == 0) {
-				l_channel_no = i;
-				break;
-			}
-		}
-		if (i >= ICCOM_CHANNEL_MAX) {
-			ret = -ENODEV;
-			dev_err(&pdev->dev, "Get Channel No failed\n");
-		}
-
-		if (ret == ICCOM_OK) {
-			l_iccom = iccom_core_alloc(&pdev->dev,
-						(int32_t)l_channel_no,
-						&iccom_drv_fops,
-						sizeof(*iccom_hw));
-			if (l_iccom == NULL) {
-				ret = -ENOMEM;
-				pr_err("[Err]iccom_core_alloc err\n");
-			}
-		}
-
-		if (ret == ICCOM_OK) {
-			iccom_hw =
-				(struct iccom_hardware_info *)l_iccom->priv;
-			ret_get_irq = platform_get_irq(pdev, 0U);
-			if (ret_get_irq <= 0) {
-				ret = ret_get_irq;
-				pr_err("[Err]Get_irq err\n");
-			} else {
-				iccom_hw->irq_no = (uint32_t)ret_get_irq;
-			}
-		}
+	if (dev_node == NULL) {
+		return -EINVAL;
+	}
 
-		if (ret == ICCOM_OK) {
-			ret = of_address_to_resource(dev_node, 0, &mfis_base);
-			if (ret != 0) {
-				dev_err(l_iccom->dev,
-					"Get MFIS base failed\n");
-			}
+	dts_name_len = strlen(dev_node->name);
+	for (i = ICCOM_CHANNEL_0; i < ICCOM_CHANNEL_MAX; i++) {
+		(void)snprintf(channel_name, ICCOM_MAX_NAME_LENGTH,
+				"%d", i);
+		ret_cmp = strncmp(&dev_node->name[dts_name_len - 1U],
+					channel_name, strlen(channel_name));
+		if (ret_cmp == 0) {
+			l_channel_no = i;
+			break;
 		}
+	}
+	if (i >= ICCOM_CHANNEL_MAX) {
+		dev_err(&pdev->dev, "[Err] Specified channel does not exist\n");
+		ret = -ENODEV;
+		goto Error;
+	}
 
-		if (ret == ICCOM_OK) {
-			reg_offset_ptr = of_get_property(dev_node,
-							"iccom,reg-offset",
-							&len);
-			if ((reg_offset_ptr == NULL) ||
-				(len < ICCOM_REG_OFFSET_LEN)) {
-				ret = -ENODEV;
-				dev_err(l_iccom->dev,
-					"No defined reg_offset\n");
-			}
-
-			cta_addr_ptr = of_get_property(dev_node,
-							"iccom,cta-memory",
-							&len);
-			if ((cta_addr_ptr == NULL) ||
-				(len < ICCOM_CTA_MEMORY_LEN)) {
-				ret = -ENODEV;
-				dev_err(l_iccom->dev,
-					"No defined cta_memory\n");
-			}
+	iccom = iccom_miscdev_alloc(&pdev->dev, (int32_t)l_channel_no,
+							&iccom_drv_fops);
+	if (IS_ERR(iccom)) {
+		pr_err("[Err] iccom_miscdev_alloc failed\n");
+		ret = PTR_ERR(iccom);
+		goto Error;
+	}
+	iccom_hw = &(iccom->hw_info);
 
-			ack_timer_ptr = of_get_property(dev_node,
-							"iccom,ack-timeout",
-							NULL);
-			if (ack_timer_ptr == NULL) {
-				ret = -ENODEV;
-				dev_err(l_iccom->dev,
-					"No defined ack_timeout\n");
-			}
+	ret = platform_get_irq(pdev, 0U);
+	if (ret <= 0) {
+		pr_err("[Err] Get_irq err\n");
+		ret = -EIO;
+		goto Error;
+	}
+	iccom_hw->irq_no = ret;
+	dev_info(iccom->dev, "Got IRQ=%d\n", iccom_hw->irq_no);
+
+	ret = request_threaded_irq(iccom_hw->irq_no,
+					NULL, (irq_handler_t)&iccom_drv_isr,
+					IRQF_ONESHOT,
+					"iccom", (void *)iccom);
+	if (ret < 0) {
+		dev_err(iccom->dev, "[Err] Cannot request IRQ\n");
+		ret = -ENODEV;
+		goto Error;
+	}
+	request_flg |= ICCOM_REQUEST_IRQ;
+	disable_irq(iccom_hw->irq_no);
 
-			trg_timer_ptr = of_get_property(dev_node,
-							"iccom,trg-timeout",
-							NULL);
-			if (trg_timer_ptr == NULL) {
-				ret = -ENODEV;
-				dev_err(l_iccom->dev,
-					"No defined trg_timeout\n");
-			}
-		}
+	ret = of_address_to_resource(dev_node, 0, &mfis_base);
+	if (ret != 0) {
+		dev_err(iccom->dev, "[Err] Get MFIS base failed\n");
+		ret = -EINVAL;
+		goto Error;
+	}
 
-		if (ret == ICCOM_OK) {
-			iccom_hw->mfis_iicr_addr =
-				mfis_base.start + be32_to_cpup(reg_offset_ptr);
-			iccom_hw->mfis_eicr_addr =
-					mfis_base.start +
-					be32_to_cpup(reg_offset_ptr + 4);
-			iccom_hw->mfis_imbr_addr =
-					mfis_base.start +
-					be32_to_cpup(reg_offset_ptr + 8);
-			iccom_hw->mfis_embr_addr =
-					mfis_base.start +
-					be32_to_cpup(reg_offset_ptr + 12);
-
-			iccom_hw->cta_addr = be32_to_cpup(cta_addr_ptr + 4);
-			iccom_hw->cta_size = be32_to_cpup(cta_addr_ptr + 12);
-
-			iccom_hw->trg_timeout = be32_to_cpup(trg_timer_ptr);
-			iccom_hw->ack_timeout_jf =
-					msecs_to_jiffies(
-						be32_to_cpup(ack_timer_ptr));
-
-			ret_irq = request_irq(iccom_hw->irq_no,
-						(irq_handler_t)&iccom_drv_isr,
-						IRQF_PROBE_SHARED,
-						l_iccom->name,
-						(void *)l_iccom);
-
-			if (ret_irq != 0) {
-				ret = -ENODEV;
-				dev_err(l_iccom->dev, "SAME IRQ registered\n");
-			} else {
-				request_flg |= ICCOM_REQUEST_IRQ;
-				disable_irq_nosync(iccom_hw->irq_no);
-			}
+	dts_val_ptr = of_get_property(dev_node, "iccom,reg-offset", &len);
+	if ((dts_val_ptr == NULL) || (len < ICCOM_REG_OFFSET_LEN)) {
+		dev_err(iccom->dev, "[Err] No defined reg_offset\n");
+		ret = -ENODEV;
+		goto Error;
+	}
+	iccom_hw->mfis_iicr_addr = mfis_base.start +
+					be32_to_cpup(dts_val_ptr);
+	iccom_hw->mfis_eicr_addr = mfis_base.start +
+					be32_to_cpup(dts_val_ptr + 4);
+	iccom_hw->mfis_imbr_addr = mfis_base.start +
+					be32_to_cpup(dts_val_ptr + 8);
+	iccom_hw->mfis_embr_addr = mfis_base.start +
+					be32_to_cpup(dts_val_ptr + 12);
+
+	dts_val_ptr = of_get_property(dev_node, "iccom,cta-memory", &len);
+	if ((dts_val_ptr == NULL) || (len < ICCOM_CTA_MEMORY_LEN)) {
+		dev_err(iccom->dev, "[Err] No defined cta_memory\n");
+		ret = -ENODEV;
+		goto Error;
+	}
+	iccom_hw->cta_addr = (uintptr_t)be32_to_cpup(dts_val_ptr + 4);
+	iccom_hw->cta_size = be32_to_cpup(dts_val_ptr + 12);
+	dev_info(iccom->dev, "CTA area: start at 0x%lx, total size 0x%x\n",
+				iccom_hw->cta_addr, iccom_hw->cta_size);
+	iccom_hw->bottom_addr = iccom_hw->cta_addr;
+	iccom_hw->upper_addr = iccom_hw->cta_addr + (iccom_hw->cta_size/2);
+
+	dts_val_ptr = of_get_property(dev_node, "iccom,ack-timeout", NULL);
+	if (dts_val_ptr == NULL) {
+		dev_err(iccom->dev, "[Err] No defined ack-timeout\n");
+		ret = -ENODEV;
+		goto Error;
+	}
+	iccom_hw->int_clear_timeout = msecs_to_jiffies(be32_to_cpup(dts_val_ptr));
 
-			req_iicr = request_mem_region(
-					(uintptr_t)iccom_hw->mfis_iicr_addr,
-					ICCOM_MFIS_LEN, l_iccom->name);
-			if (req_iicr == NULL) {
-				ret = -ENODEV;
-				dev_err(l_iccom->dev, "Overlap IICR\n");
-			} else {
-				request_flg |= ICCOM_REQUEST_IICR;
-			}
-			req_eicr = request_mem_region(
-					(uintptr_t)iccom_hw->mfis_eicr_addr,
-					ICCOM_MFIS_LEN, l_iccom->name);
-			if (req_eicr == NULL) {
-				ret = -ENODEV;
-				dev_err(l_iccom->dev, "Overlap EICR\n");
-			} else {
-				request_flg |= ICCOM_REQUEST_EICR;
-			}
-			req_imbr = request_mem_region(
-					(uintptr_t)iccom_hw->mfis_imbr_addr,
-					ICCOM_MFIS_LEN, l_iccom->name);
-			if (req_imbr == NULL) {
-				ret = -ENODEV;
-				dev_err(l_iccom->dev, "Overlap IMBR\n");
-			} else {
-				request_flg |= ICCOM_REQUEST_IMBR;
-			}
-			req_embr = request_mem_region(
-					(uintptr_t)iccom_hw->mfis_embr_addr,
-					ICCOM_MFIS_LEN, l_iccom->name);
-			if (req_embr == NULL) {
-				ret = -ENODEV;
-				dev_err(l_iccom->dev, "Overlap EMBR\n");
-			} else {
-				request_flg |= ICCOM_REQUEST_EMBR;
-			}
-			req_cta = request_mem_region(
-						(uintptr_t)iccom_hw->cta_addr,
-						(uintptr_t)iccom_hw->cta_size,
-						l_iccom->name);
-			if (req_cta == NULL) {
-				ret = -ENODEV;
-				dev_err(&pdev->dev, "Overlap CTA\n");
-			} else {
-				request_flg |= ICCOM_REQUEST_CTA;
-			}
-		}
+	dts_val_ptr = of_get_property(dev_node, "iccom,int-clear-timeout", NULL);
+	if (dts_val_ptr == NULL) {
+		dev_err(iccom->dev, "[Err] No defined int-clear-timeout\n");
+		ret = -ENODEV;
+		goto Error;
+	}
+	iccom_hw->ack_timeout = msecs_to_jiffies(be32_to_cpup(dts_val_ptr));
 
-		if (ret == ICCOM_OK) {
-			ret = iccom_core_add(l_iccom);
-		}
+	dts_val_ptr = of_get_property(dev_node, "iccom,read-timeout", NULL);
+	if (dts_val_ptr == NULL) {
+		dev_err(iccom->dev, "[Err] No defined read-timeout\n");
+		ret = -ENODEV;
+		goto Error;
+	}
+	iccom_hw->read_timeout = msecs_to_jiffies(be32_to_cpup(dts_val_ptr));
+
+	req_res = request_mem_region(iccom_hw->mfis_iicr_addr,
+					ICCOM_MFIS_LEN, iccom->name);
+	if (req_res == NULL) {
+		dev_err(iccom->dev, "[Err] Cannot request IICR region\n");
+		ret = -ENODEV;
+		goto Error;
+	}
+	request_flg |= ICCOM_REQUEST_IICR;
+
+	req_res = request_mem_region(iccom_hw->mfis_eicr_addr,
+					ICCOM_MFIS_LEN, iccom->name);
+	if (req_res == NULL) {
+		dev_err(iccom->dev, "[Err] Cannot request EICR region\n");
+		ret = -ENODEV;
+		goto Error;
+	}
+	request_flg |= ICCOM_REQUEST_EICR;
+
+	req_res = request_mem_region(iccom_hw->mfis_imbr_addr,
+					ICCOM_MFIS_LEN, iccom->name);
+	if (req_res == NULL) {
+		dev_err(iccom->dev, "[Err] Cannot request IMBR region\n");
+		ret = -ENODEV;
+		goto Error;
+	}
+	request_flg |= ICCOM_REQUEST_IMBR;
+
+	req_res = request_mem_region(iccom_hw->mfis_embr_addr,
+					ICCOM_MFIS_LEN, iccom->name);
+	if (req_res == NULL) {
+		dev_err(iccom->dev, "[Err] Cannot request EMBR region\n");
+		ret = -ENODEV;
+		goto Error;
+	}
+	request_flg |= ICCOM_REQUEST_EMBR;
+
+	req_res = request_mem_region( iccom_hw->cta_addr,
+					(uintptr_t)iccom_hw->cta_size,
+					iccom->name);
+	if (req_res == NULL) {
+		dev_err(&pdev->dev, "[Err] Cannot request CTA region\n");
+		ret = -ENODEV;
+		goto Error;
+	}
+	request_flg |= ICCOM_REQUEST_CTA;
 
-		if (ret == ICCOM_OK) {
-			platform_set_drvdata(pdev, l_iccom);
-			pr_info("ICCOM Channel%d ready\n", l_channel_no);
-			pr_debug("Channel %d info\n", l_channel_no);
-			pr_debug("IRQ: 0x%X", iccom_hw->irq_no);
-			pr_debug("MFISARIICR: 0x%X\n",
-				iccom_hw->mfis_iicr_addr);
-			pr_debug("MFISAREICR: 0x%X\n",
-				iccom_hw->mfis_eicr_addr);
-			pr_debug("MFISARIMBR: 0x%X\n",
-				iccom_hw->mfis_imbr_addr);
-			pr_debug("MFISAREMBR: 0x%X\n",
-				iccom_hw->mfis_embr_addr);
-			pr_debug("CTA: 0x%X\n", iccom_hw->cta_addr);
-			pr_debug("ACK_TIMEOUT: %llu\n", iccom_hw->ack_timeout_jf);
-			pr_debug("TRG_TIMEOUT: %d\n", iccom_hw->trg_timeout);
-		} else {
-			if (l_iccom != NULL) {
-				iccom_drv_release_iccom(l_iccom, request_flg);
-				(void)iccom_core_free(l_iccom);
-			}
-			if (l_channel_no != ICCOM_CHANNEL_MAX) {
-				pr_err("[Err]channel %d not use\n",
-					l_channel_no);
-			}
-		}
-	} else {
-		/* No operation */
+	ret = iccom_miscdev_add(iccom);
+	if (ret < 0) {
+		dev_err(&pdev->dev, "[Err] iccom_miscdev_add failed");
+		goto Error;
 	}
 
-	pr_debug("%s: End ret = %d\n", __func__, ret);
+	platform_set_drvdata(pdev, iccom);
+	dev_info(iccom->dev, "Probe completed\n");
+
+	return 0;
 
+Error:
+	iccom_drv_release_hw(iccom, request_flg);
+	iccom_miscdev_free(iccom);
+	
 	return ret;
 }
 
 static int32_t iccom_drv_remove(struct platform_device *pdev)
 {
-	int32_t ret = ICCOM_OK;
-	struct iccom *l_iccom;
-
-	pr_debug("%s: Start\n", __func__);
+	int32_t ret = 0;
+	struct iccom *iccom;
 
-	l_iccom = platform_get_drvdata(pdev);
-	if (l_iccom != NULL) {
-		iccom_drv_release_iccom(l_iccom, ICCOM_REQUEST_ALL);
-		ret = iccom_core_del(l_iccom);
+	iccom = platform_get_drvdata(pdev);
+	if (iccom != NULL) {
+		iccom_drv_release_hw(iccom, ICCOM_REQUEST_ALL);
+		ret = iccom_miscdev_del(iccom);
 	}
 
-	pr_debug("%s: End ret = %d\n", __func__, ret);
-
 	return ret;
 }
 
@@ -942,14 +729,6 @@ static struct platform_driver iccom_driver = {
 		   },
 };
 
-static struct platform_device iccom_device = {
-	.name = "iccom",
-	.id = 0,
-	.dev = {
-			.release = &iccom_drv_device_release
-		},
-};
-
 static __init int32_t iccom_drv_init(void)
 {
 	int32_t ret;
@@ -957,114 +736,18 @@ static __init int32_t iccom_drv_init(void)
 	pr_info("%s initialization(R-Car Rev.%s)\n",
 		ICCOM_MODULE_NAME, VERSION_OF_RENESAS);
 
-	pr_debug("%s: Start\n", __func__);
-
 	ret = platform_driver_register(&iccom_driver);
-	if (ret == 0) {
-		ret = platform_device_register(&iccom_device);
-		if (ret != 0) {
-			platform_driver_unregister(&iccom_driver);
-		}
-	}
-
-	pr_info("%s initialization finish\n", ICCOM_MODULE_NAME);
-
-	pr_debug("%s: End\n", __func__);
 
 	return ret;
 }
 
 static void __exit iccom_drv_exit(void)
 {
-
 	pr_info("%s de-initialization\n", ICCOM_MODULE_NAME);
 
-	pr_debug("%s: Start\n", __func__);
-
-	platform_device_unregister(&iccom_device);
 	platform_driver_unregister(&iccom_driver);
 
 	pr_info("%s de-initialization finish\n", ICCOM_MODULE_NAME);
-
-	pr_debug("%s: End\n", __func__);
-}
-
-static void iccom_drv_device_release(struct device *dev)
-{
-	pr_debug("%s: dev=%p\n", __func__, dev);
-}
-
-static void iccom_drv_release_channel(struct iccom_channel *channel)
-{
-	struct iccom_communication_info *iccom_comm = NULL;
-
-	pr_debug("%s: Start\n", __func__);
-
-	if (channel != NULL) {
-		iccom_comm = (struct iccom_communication_info *)channel->priv;
-	}
-
-	if (iccom_comm != NULL) {
-		mutex_destroy(&iccom_comm->mutex_poll_intbit);
-		if (iccom_comm->cta_addr != NULL) {
-			iounmap(iccom_comm->cta_addr);
-		}
-
-		if (iccom_comm->mfis_embr_addr != NULL) {
-			iounmap(iccom_comm->mfis_embr_addr);
-		}
-
-		if (iccom_comm->mfis_imbr_addr != NULL) {
-			iounmap(iccom_comm->mfis_imbr_addr);
-		}
-
-		if (iccom_comm->mfis_eicr_addr != NULL) {
-			iounmap(iccom_comm->mfis_eicr_addr);
-		}
-
-		if (iccom_comm->mfis_iicr_addr != NULL) {
-			iounmap(iccom_comm->mfis_iicr_addr);
-		}
-		devm_kfree(channel->iccom->dev, channel);
-	}
-
-	pr_debug("%s: End\n", __func__);
-}
-
-static void iccom_drv_release_iccom(struct iccom *iccom, uint8_t request_flg)
-{
-	struct iccom_hardware_info *iccom_hw;
-
-	dev_dbg(iccom->dev, "%s: Start flg = 0x%X\n", __func__, request_flg);
-
-	iccom_hw = (struct iccom_hardware_info *)iccom->priv;
-	if (iccom_hw != NULL) {
-		if ((request_flg & ICCOM_REQUEST_IICR) != 0U) {
-			release_mem_region((uintptr_t)iccom_hw->mfis_iicr_addr,
-					ICCOM_MFIS_LEN);
-		}
-		if ((request_flg & ICCOM_REQUEST_EICR) != 0U) {
-			release_mem_region((uintptr_t)iccom_hw->mfis_eicr_addr,
-					ICCOM_MFIS_LEN);
-		}
-		if ((request_flg & ICCOM_REQUEST_IMBR) != 0U) {
-			release_mem_region((uintptr_t)iccom_hw->mfis_imbr_addr,
-					ICCOM_MFIS_LEN);
-		}
-		if ((request_flg & ICCOM_REQUEST_EMBR) != 0U) {
-			release_mem_region((uintptr_t)iccom_hw->mfis_embr_addr,
-					ICCOM_MFIS_LEN);
-		}
-		if ((request_flg & ICCOM_REQUEST_CTA) != 0U) {
-			release_mem_region((uintptr_t)iccom_hw->cta_addr,
-					(uintptr_t)iccom_hw->cta_size);
-		}
-		if ((request_flg & ICCOM_REQUEST_IRQ) != 0U) {
-			free_irq(iccom_hw->irq_no, (void *)iccom);
-		}
-	}
-
-	pr_debug("%s: End\n", __func__);
 }
 
 module_init(iccom_drv_init);
diff --git a/iccom_internal.h b/iccom_internal.h
new file mode 100644
index 0000000..db00846
--- /dev/null
+++ b/iccom_internal.h
@@ -0,0 +1,71 @@
+#ifndef iccom_miscdev_H
+#define iccom_miscdev_H
+
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/miscdevice.h>
+#include <linux/list.h>
+
+#define VERSION_OF_RENESAS		"1.0.0"
+
+#define ICCOM_MAX_ICCOM_DEV_NAME	(128)
+
+struct iccom_communication_info {
+	wait_queue_head_t write_q;
+	wait_queue_head_t read_q;
+	uint32_t *mfis_iicr_addr;
+	uint32_t *mfis_eicr_addr;
+	uint32_t *mfis_imbr_addr;
+	uint32_t *mfis_embr_addr;
+	struct mutex comm_mutex;
+	uint8_t *bottom_addr;  // From CA55 to G4MH
+	uint8_t *upper_addr; // From G4MH to CA55
+	uint32_t max_transaction_size; // Max size for either TX or RX
+	uint8_t *rx_data_buff;
+	uint32_t valid_rx_data;
+	uint8_t ack_received;
+};
+
+struct iccom_hardware_info {
+	uint32_t irq_no;
+	uintptr_t mfis_iicr_addr;
+	uintptr_t mfis_eicr_addr;
+	uintptr_t mfis_imbr_addr;
+	uintptr_t mfis_embr_addr;
+	uintptr_t cta_addr;
+	uint32_t cta_size;
+	uintptr_t bottom_addr;
+	uintptr_t upper_addr;
+	uint64_t read_timeout; // jiffies
+	uint64_t ack_timeout; // jiffies
+	uint64_t int_clear_timeout; // jiffies
+};
+
+struct iccom {
+	struct list_head list;
+	int8_t name[ICCOM_MAX_ICCOM_DEV_NAME];
+	const struct iccom_ops *ops;
+	struct device *dev;
+	struct miscdevice miscdev;
+	struct mutex data_mutex;
+	uint8_t is_open;
+	struct iccom_hardware_info hw_info;
+	struct iccom_communication_info *comm_info;
+};
+
+struct iccom_ops {
+	struct module *owner;
+	const char *type;
+	int32_t (*open)(struct iccom *iccom);
+	int32_t (*close)(struct iccom *iccom);
+	int32_t (*read)(struct iccom *iccom, uint8_t *buf, uint32_t count);
+	int32_t (*write)(struct iccom *iccom, uint8_t *buf, uint32_t count);
+};
+
+struct iccom *iccom_miscdev_alloc(struct device *dev, int32_t channel_no,
+				const struct iccom_ops *ops);
+int32_t iccom_miscdev_free(struct iccom *iccom);
+int32_t iccom_miscdev_add(struct iccom *iccom);
+int32_t iccom_miscdev_del(struct iccom *iccom);
+
+#endif /* iccom_miscdev_H */
diff --git a/iccom_ioctl.h b/iccom_ioctl.h
new file mode 100644
index 0000000..5c8b280
--- /dev/null
+++ b/iccom_ioctl.h
@@ -0,0 +1,31 @@
+#ifndef ICCOM_H
+#define ICCOM_H
+
+#include <linux/kernel.h>
+
+enum iccom_channel_number {
+	ICCOM_CHANNEL_0 = 0,
+	ICCOM_CHANNEL_1,
+	ICCOM_CHANNEL_2,
+	ICCOM_CHANNEL_3,
+	ICCOM_CHANNEL_4,
+	ICCOM_CHANNEL_5,
+	ICCOM_CHANNEL_6,
+	ICCOM_CHANNEL_7,
+	ICCOM_CHANNEL_MAX
+};
+
+// ioctl stuff
+#define ICCOM_IOCTL_MAGIC		0xA5
+#define ICCOM_IOCTL_CMD_WRITE		1
+#define ICCOM_IOCTL_CMD_READ		2
+
+struct iccom_ioctl_pkt {
+	uint32_t length;
+	uint8_t* data;
+};
+
+#define ICCOM_IOCTL_WRITE	_IOW(ICCOM_IOCTL_MAGIC, ICCOM_IOCTL_CMD_WRITE, struct iccom_ioctl_pkt *)
+#define ICCOM_IOCTL_READ	_IOR(ICCOM_IOCTL_MAGIC, ICCOM_IOCTL_CMD_READ, struct iccom_ioctl_pkt *)
+
+#endif /* ICCOM_H */
diff --git a/iccom_miscdev.c b/iccom_miscdev.c
new file mode 100644
index 0000000..898a0b8
--- /dev/null
+++ b/iccom_miscdev.c
@@ -0,0 +1,215 @@
+#include <linux/module.h>
+#include <linux/kernel.h>
+#include <linux/init.h>
+#include <linux/types.h>
+#include <linux/cdev.h>
+#include <linux/platform_device.h>
+#include <linux/device.h>
+#include <linux/fs.h>
+#include <linux/file.h>
+#include <linux/list.h>
+#include <linux/miscdevice.h>
+#include <linux/poll.h>
+
+#include "iccom_ioctl.h"
+#include "iccom_internal.h"
+
+static LIST_HEAD(g_iccom_list_head);
+
+static int iccom_miscdev_open(struct inode *inode, struct file *filp)
+{
+	int32_t ret;
+	struct iccom *iccom;
+
+	iccom = container_of(filp->private_data, struct iccom, miscdev);
+
+	ret = iccom->ops->open(iccom);
+
+	return ret;
+}
+
+static int iccom_miscdev_release(struct inode *inode, struct file *filp)
+{
+	struct iccom *iccom;
+	int32_t ret;
+
+	iccom = container_of(filp->private_data, struct iccom, miscdev);
+
+	ret = iccom->ops->close(iccom);
+
+	return ret;
+}
+
+static ssize_t iccom_miscdev_read(struct file *filp, char __user *buf,
+				size_t count, loff_t *pos)
+{
+	int32_t ret;
+	struct iccom *iccom;
+
+	iccom = container_of(filp->private_data, struct iccom, miscdev);
+
+	//dev_info(iccom->dev, "[ICCOM] asked to read %d bytes\n", cmd.count);
+	ret = iccom->ops->read(iccom, (uint8_t *)buf, count);
+	//dev_info(iccom->dev, "[ICCOM] read returned %d\n", ret);
+
+	return (ssize_t)ret;
+}
+
+static ssize_t iccom_miscdev_write(struct file *filp, const char __user *buf,
+				size_t count, loff_t *pos)
+{
+	int32_t ret;
+	struct iccom *iccom;
+
+	iccom = container_of(filp->private_data, struct iccom, miscdev);
+
+	//dev_info(iccom->dev, "[ICCOM] asked to write %d bytes\n", cmd.count);
+	ret = iccom->ops->write(iccom, (uint8_t *)buf, count);
+	//dev_info(iccom->dev, "[ICCOM] write returned %d\n", ret);
+
+	return (ssize_t)ret;
+}
+
+static unsigned int iccom_miscdev_poll(struct file *filp, struct poll_table_struct *wait)
+{
+	struct iccom *iccom;
+	unsigned int mask = 0;
+
+	iccom = container_of(filp->private_data, struct iccom, miscdev);
+	//dev_info(iccom->dev, "Poll returns that read is possible\n");
+
+	mask = POLLIN | POLLRDNORM;
+
+	return mask;
+}
+
+static long iccom_miscdev_ioctl(struct file *filp, unsigned int cmd, unsigned long param)
+{
+	struct iccom *iccom;
+	struct iccom_ioctl_pkt ioctl_pkt;
+	int32_t ret;
+
+	iccom = container_of(filp->private_data, struct iccom, miscdev);
+
+	if (_IOC_TYPE(cmd) != ICCOM_IOCTL_MAGIC) {
+		dev_err(iccom->dev, "[Err] ioctl wrong magic number; expected %d got %d\n",
+				ICCOM_IOCTL_MAGIC, _IOC_TYPE(cmd));
+		return -EINVAL;
+	}
+
+	if (!access_ok((void*)param, sizeof(struct iccom_ioctl_pkt))) {
+		dev_err(iccom->dev, "[Err] ioctl data is not accessible\n");
+		return -EINVAL;
+	}
+	if (copy_from_user(&ioctl_pkt, (void*)param, sizeof(struct iccom_ioctl_pkt)) != 0) {
+		dev_err(iccom->dev, "[Err] cannot copy data ptr from userspace\n");
+		return -EINVAL;
+	}
+	//dev_info(iccom->dev, "len=%d addr=%p\n", ioctl_pkt.length, ioctl_pkt.data);
+	
+	switch (_IOC_NR(cmd)) {
+		case ICCOM_IOCTL_CMD_WRITE:
+			ret = iccom->ops->write(iccom, ioctl_pkt.data, ioctl_pkt.length);
+			break;
+		case ICCOM_IOCTL_CMD_READ:
+			ret = iccom->ops->read(iccom, ioctl_pkt.data, ioctl_pkt.length);
+			break;
+		default:
+			dev_err(iccom->dev, "[Err] Unknown iccom ioctl command\n");
+			return -EINVAL;
+	}
+
+	// Read and write command return the number of bytes read/written when
+	// successful, so we adjust the value here for ioctl.
+	ret = (ret > 0) ? 0 : ret;
+	
+	return ret;
+}
+
+const struct file_operations iccom_fops = {
+	.owner = THIS_MODULE,
+	.read = iccom_miscdev_read,
+	.write = iccom_miscdev_write,
+	.open = iccom_miscdev_open,
+	.release = iccom_miscdev_release,
+	.poll = iccom_miscdev_poll,
+	.unlocked_ioctl = iccom_miscdev_ioctl,
+};
+
+struct iccom *iccom_miscdev_alloc(struct device *dev, int32_t channel_no,
+				const struct iccom_ops *ops)
+{
+	struct iccom *iccom;
+
+	if ((dev == NULL) || (ops == NULL) ||
+	    (ops->open == NULL) || (ops->close  == NULL) ||
+	    (ops->read == NULL) || (ops->write == NULL)) {
+		pr_err("[Err]Param err dev = %p, ops = %p\n", dev, ops);
+		iccom = NULL;
+		return ERR_PTR(-EINVAL);
+	}
+
+	iccom = (struct iccom *)devm_kzalloc(dev,
+						sizeof(struct iccom), GFP_KERNEL);
+	if (iccom == NULL) {
+		dev_err(dev, "[Err]No memory for allocating iccom struct\n");
+		return ERR_PTR(-ENOMEM);
+	}
+
+	iccom->ops = ops;
+	iccom->dev = dev;
+	iccom->is_open = 0U;
+
+	(void)snprintf(iccom->name, sizeof(iccom->name), "iccom%d",
+					channel_no);
+	mutex_init(&iccom->data_mutex);
+
+	iccom->miscdev.parent = dev;
+	iccom->miscdev.minor = MISC_DYNAMIC_MINOR;
+	iccom->miscdev.name = iccom->name;
+	iccom->miscdev.fops = &iccom_fops;
+
+	INIT_LIST_HEAD(&iccom->list);
+
+	return iccom;
+}
+
+int32_t iccom_miscdev_free(struct iccom *iccom)
+{
+	list_del(&iccom->list);
+	mutex_destroy(&iccom->data_mutex);
+	devm_kfree(iccom->dev, iccom);
+
+	return 0;
+}
+
+int32_t iccom_miscdev_add(struct iccom *iccom)
+{
+	int32_t rc;
+
+	if (iccom == NULL) {
+		pr_err("[Err]iccom NULL\n");
+		return -EINVAL;
+	}
+
+	rc = misc_register(&iccom->miscdev);
+	if (rc < 0) {
+		pr_err("[Err]misc_register failed %d\n", rc);
+		return rc;
+	}
+
+	dev_set_drvdata(iccom->miscdev.this_device, iccom);
+	list_add_tail(&iccom->list, &g_iccom_list_head);
+
+	return rc;
+}
+
+int32_t iccom_miscdev_del(struct iccom *iccom)
+{
+	int32_t ret;
+
+	misc_deregister(&iccom->miscdev);
+	ret = iccom_miscdev_free(iccom);
+
+	return ret;
+}
-- 
2.25.1

